#ifndef API_H
#define API_H

#include <QColor>
#include <QStringList>

enum ErrorLevel {NoError,Warning,Aborted};

class API
{
public:
	API();
	void initCommand();
	void parseInput (const QString &input);
	QString command();
	QStringList parameters();
	int paramCount();
	QString errorMessage();
	QString errorDescription();
	ErrorLevel errorLevel();
	void setError (ErrorLevel level,const QString &description);
	void resetError();
	bool checkParamCount (QList <int> plist);
	bool checkParamCount (const int &index);
	bool checkParamIsInt (const int &index);
	int parInt (bool &,const uint &index);
	QString parString(bool &ok,const int &index);
	bool parBool (bool &ok, const int &index);
	QColor parColor (bool &ok, const int &index);
private:
	QString input;
	QString com;
	QStringList paramList;
	QString errMessage;
	QString errDescription;
	ErrorLevel errLevel;
};

#endif
