#ifndef SELECTION_H
#define SELECTION_H

#include "linkablemapobj.h"
#include "mapcenterobj.h"

enum SelectionType {Undefined,Branch,MapCenter,FloatImage};

class Selection 
{
public:
	Selection ();
	~Selection();
	void copy(const Selection&);
	void clear();
	void setMapCenter (MapCenterObj *);
	
	bool select (LinkableMapObj*);
	bool select (const QString &);
	bool reselect ();
	void unselect ();
	bool isEmpty();
	uint count();
	SelectionType type();
	LinkableMapObj * first();		// first in selection list
	LinkableMapObj * single();		// NULL, if multiple selected
	BranchObj* getBranch();
	FloatImageObj* getFloatImage();

	QString getSelectString();

private:
	void init();
	QList <LinkableMapObj*> selectList;
	QList <LinkableMapObj*> lastSelectList;
	MapCenterObj *mapCenter;
};
#endif

